//============================================================================
// Name        : aconvert.cpp
// Author      : Martin Zak
// Version     :
// Copyright   : 
// Description :
//============================================================================

#include <iostream>

#include "automaton/AutomatonParser.h"
#include "automaton/UnknownAutomaton.h"
#include "AutomatonFactory.h"
#include "AlibException.h"
#include "sax/SaxInterface.h"

#include "DotConverter.h"

using namespace std;
using namespace automaton;
using namespace sax;
using namespace alib;

int main(int argc, char** argv) {
	list<Token> tokens;
	try {

		if (argc > 1) {
			if (string("-h").compare(argv[1]) == 0) {
				cout
						<< "Automaton converting tool. Supports only dot format at the moment.\nUsage: aconvert [automaton.xml]\n";
				return -1;
			}

			SaxInterface::parseFile(argv[1], tokens);
		} else {
			string input(istreambuf_iterator<char>(cin),
					(istreambuf_iterator<char>()));
			SaxInterface::parseMemory(input, tokens);
		}

		UnknownAutomaton unknownAutomaton = AutomatonParser::parse(tokens);
		Automaton* automaton = AutomatonFactory::buildAutomaton(unknownAutomaton);
		DotConverter::convert(*automaton, cout);

	} catch (AlibException& e) {
		cout << e.what() << endl;
		return 0;
	}
}
