#include <iostream>
#include <set>

#include "automaton/UnknownAutomaton.h"
#include "AutomatonFactory.h"
#include "AlibException.h"
#include "FSMDeterminizer.h"


using namespace std;
using namespace automaton;
using namespace determinization;
using namespace alib;


int main(int argc, char** argv) {
    UnknownAutomaton automaton;
    
    try {
        string input(istreambuf_iterator<char>(cin), (istreambuf_iterator<char>()));
        automaton = AutomatonFactory::fromString(input);
        
        Automaton* knownAutomaton = AutomatonFactory::buildAutomaton(automaton);
        // TODO check that automaton is FSM
        FSMDeterminizer determinizer((FSM*) knownAutomaton);
        FSM* deterministicFSM = determinizer.determinize();
        deterministicFSM->toXML(cout);
        
        delete knownAutomaton;
        delete deterministicFSM;
        
    } catch (AlibException& e) {
        cout << e.what() << endl;
        return 0;
    }
}