/*
 * Symbol.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Martin Zak
 */

#include "Symbol.h"

namespace alphabet {

Symbol::Symbol(const std::string& symbol) {
	this->symbol = symbol;
}

const std::string& Symbol::getSymbol() const {
	return symbol;
}

bool Symbol::operator <(const Symbol& other) const {
	return symbol < other.symbol;
}

bool Symbol::operator ==(const Symbol& other) const {
	return symbol == other.symbol;
}

bool Symbol::operator !=(const Symbol& other) const {
	return symbol != other.symbol;
}

std::ostream& operator<<(std::ostream& out, const Symbol& symbol) {

	out << "Symbol " << (symbol.symbol == "" ? "\\epsilon" : symbol.symbol);
	return out;
}

} /* namespace language */
