/*
 * UnrestrictedGrammar.h
 *
 *  Created on: Nov 17, 2013
 *      Author: martin
 */

#ifndef UNRESTRICTEDGRAMMAR_H_
#define UNRESTRICTEDGRAMMAR_H_

#include "Grammar.h"

namespace grammar {

/**
 * Unrestricted grammar. Type 0 in Chomsky hierarchy. Produces recursively enumerable language.
 */
class UnrestrictedGrammar: public Grammar {
protected:

	/**
	 * Checks that left side of the rule is not empty and that both sides of the rule contain only
	 * symbols that are terminal or nonterminal in this grammar.
	 * @param rule Rule to check
	 * @return true when rule is valid, false otherwise
	 */
	bool isValidRule(const Rule& rule) const;
public:
	UnrestrictedGrammar();
	UnrestrictedGrammar(const set<Symbol>& nonTerminalSymbols, const set<Symbol>& terminalSymbols,
			const Symbol& startSymbol);
};

} /* namespace grammar */
#endif /* UNRESTRICTEDGRAMMAR_H_ */
