/*
 * Alternation.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: martin
 */

#include "Alternation.h"

namespace regexp {

Alternation::Alternation() {
}

Alternation::Alternation(const Alternation& other) {
	for (auto element : other.elements) {
		elements.push_back(element->clone());
	}
}

Alternation& Alternation::operator =(const Alternation& other) {
	if (this == &other) {
		return *this;
	}

	for (auto element : elements) {
		delete element;
	}
	elements.clear();

	for (auto element : other.elements) {
		elements.push_back(element->clone());
	}

	return *this;
}

Alternation::~Alternation() {
	for (auto element : elements) {
		delete element;
	}
	elements.clear();
}

list<RegExpElement*>& Alternation::getElements() {
	return elements;
}

RegExpElement* Alternation::clone() const {
	return new Alternation(*this);
}

} /* namespace regexp */

