/*
 * Concatenation.cpp
 *
 *  Created on: Nov 27, 2013
 *      Author: martin
 */

#include "Concatenation.h"

namespace regexp {

Concatenation::Concatenation() {
}

Concatenation::Concatenation(const Concatenation& other) {
	for (auto element : other.elements) {
		elements.push_back(element->clone());
	}
}

Concatenation& Concatenation::operator =(const Concatenation& other) {
	if(this == &other) {
		return *this;
	}

	for (auto element : elements) {
		delete element;
	}
	elements.clear();

	for (auto element : other.elements) {
		elements.push_back(element->clone());
	}

	return *this;
}

Concatenation::~Concatenation() {
	for (auto element : elements) {
		delete element;
	}
	elements.clear();
}

list<RegExpElement*>& Concatenation::getElements() {
	return elements;
}

RegExpElement* Concatenation::clone() const {
	return new Concatenation(*this);
}

} /* namespace regexp */
