/*
 * Concatenation.h
 *
 *  Created on: Nov 27, 2013
 *      Author: martin
 */

#ifndef CONCATENATION_H_
#define CONCATENATION_H_

#include <list>
#include "RegExpElement.h"

namespace regexp {

using namespace std;

/**
 * Represents concatenation operator in the regular expression. Contains list of RegExpElement
 * as operands of the operator.
 */
class Concatenation: public RegExpElement {
private:
	list<RegExpElement*> elements;
public:
	Concatenation();
	Concatenation(const Concatenation& other);
	Concatenation& operator =(const Concatenation& other);
	~Concatenation();

	/**
	 * @return list of operands
	 */
	list<RegExpElement*>& getElements();

	/**
	 * @copydoc RegExpElement::clone() const
	 */
	RegExpElement* clone() const;

};

} /* namespace regexp */
#endif /* CONCATENATION_H_ */
