/*
 * RegExp.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: martin
 */

#include "RegExp.h"
#include "RegExpPrinter.h"

#include <iostream>

namespace regexp {

RegExp::RegExp() {
	regExp = NULL;
}

RegExp::RegExp(const RegExp& other) {
	if (other.regExp != NULL) {
		regExp = other.regExp->clone();
	} else {
		regExp = NULL;
	}
}

RegExp::RegExp(const RegExpElement* regExp) {
	if (regExp != NULL) {
		this->regExp = regExp->clone();
	} else {
		this->regExp = NULL;
	}
}

RegExp& RegExp::operator =(const RegExp& other) {
	if (this == &other) {
		return *this;
	}

	if (regExp != NULL) {
		delete regExp;
	}

	if (other.regExp != NULL) {
		regExp = other.regExp->clone();
	} else {
		regExp = NULL;
	}

	return *this;
}

RegExp::~RegExp() {
	if (regExp != NULL) {
		delete regExp;
	}

	regExp = NULL;
}

RegExpElement* RegExp::getRegExp() {
	return regExp;
}

void RegExp::setRegExp(RegExpElement* regExp) {
	this->regExp = regExp;
}

void RegExp::toXML(ostream& out) {
	RegExpPrinter::toXML(*this, out);
}

} /* namespace regexp */
